# RiiiverSDKSample 1.3.0 Release Note

## 概要
RiiiverSDKSample 1.3.0 は RiiiverSDK 1.6.0 を使用しています。

## 新規機能
### お知らせ機能
アプリを利用しているユーザーにRiiiverに関するお知らせを表示することができます。(例えばiiideaの追加やPieceの改善など)  
お知らせの内容はRiiiver運営で管理しており、RiiiverSDK利用者様(企業様)と相談しながら内容を決めることができます。  
お知らせ機能の基本情報はerconfiguration.jsonのERNewsに設定します。(ERNewsのAppNameにご自身のアプリ名をご指定ください)

```json
{
    "Version": "1.0",
    "ERAuth":{
        "Host": "https://str.riiiver.com",
        "VendorId": "Your Vendor ID that is registered to Riiiver.",
        "AppName": "Your App name that is registered to Riiiver."
    },
    "ERNews": {
        "BaseUrl": "https://newslist.riiiver.com",
        "AppName": "Your App name that is registered to Riiiver."
    }
}
```

#### 実装方法(iOS)
新規に以下のクラスとAPIが追加されています。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
|  openNews(webView: WKWebView, deviceIds: [String]) |  ERNewsManager  | inputパラメータのdeviceIdsで指定したデバイス情報のお知らせ内容をinputパラメータで渡したwebViewに表示する。 | サンプルアプリの NewsInfoViewController をご確認ください。 |
|  isUpdated(_ markedAsReadDate: Date?, _ updatedDate: Date?) -> Bool  |  ERNewsManager  | 新規に追加したお知らせ内容に対してユーザーの未読/既読状態を取得する。 | サンプルアプリの SampleViewController をご確認ください。 (お知らせを開くボタン(News)の上部に未読/既読状態に合わせて「new!」と表示) |

#### 実装方法(Android)
新規に以下のクラスとAPIが追加されています。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
|  showNews(WebView webView, List<String> deviceIds) |  ERSDK  | inputパラメータで渡したwebViewにお知らせページを表示する。 | サンプルアプリの NewsInfoFragment をご確認ください。 |
|  isUnreadNews(Completion1<Boolean> completion) |  ERSDK  | 新規に追加したお知らせ内容に対してユーザーの未読/既読状態を取得する。 | サンプルアプリの IiideaListFragment をご確認ください。 (お知らせを開くボタン(News)の上部に未読/既読状態に合わせて「new!」と表示) |

### PreferencesView読み込み中表示機能
iiideaの設定画面(PreferencesView)を開く際に最初に読み込み中を示す画面を表示することができます。  
PreferencesViewで使用するWebコンテンツにloader.htmlを追加すると機能します。  
サンプルアプリに内包されているPreferencesViewのWebコンテンツをそのままご使用いただければ本機能を使用した状態になります。  
　
```bash
Preferences
├── element
├── js
├── css
├── img
├── index.html
└── loader.html ★追加ファイル
```

loader.htmlを追加するとPreferencesViewを読み込む際に即座にloader.htmlを読み込んで表示します。  
その後、PreferencesViewの読み込みが完了すると従来のiiideaの設定画面を表示します。  
※ loader.html は必須ではありません。  

### Preferences CustomOrder 機能
PieceJsonにiiideaの設定画面(PreferencesView)向けに特定の設定値を設けて、iiideaの設定画面をカスタマイズできる機能を追加しました。  
この機能追加に合わせてPreferencesViewで使用するWebコンテンツを更新していますので、RiiiverSDK 1.6.0 を使用する場合は必ずサンプルアプリに内包されているWebコンテンツをご使用ください。  

### iiidea強制ダウンロード機能
ユーザーがストアからiiideaをダウンロードすることなくアプリに最初から特定のiiiideaをダウンロードした状態にすることができます。  
本機能を使用する場合は後述の PersonalInfo画面表示機能 を使った対応を必ず行ってください。  

#### 実装方法(iOS)
新規に以下のクラスとAPIが追加されています。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
| forcedDownloadApplet(appletIds: [String], completion: @escaping (_ error: Error?) -> Void) |  ERSDK  | inputパラメータのappletIdsで指定したiiideaをダウンロード状態に変更する。変更した後にERSDKクラスのgetMyAppletsをコールすることで本APIで指定したiiideaを含め、ユーザーのダウンロード済みiiideaを取得することができる。 | サンプルアプリの ViewController をご確認ください。 (ログイン後にAPIをコールしてダウンロードさせたいiiideaを設定) |

#### 実装方法(Android)
新規に以下のクラスとAPIが追加されています。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
| forcedDownloadApplet(List<String> appletIds, Completion0 completion) |  ERSDK  | inputパラメータのappletIdsで指定したiiideaをダウンロード状態に変更する。変更した後にERSDKクラスのgetMyAppletsをコールすることで本APIで指定したiiideaを含め、ユーザーのダウンロード済みiiideaを取得することができる。 | サンプルアプリの MainActivity をご確認ください。 (ログイン後にAPIをコールしてダウンロードさせたいiiideaを設定) |

### PersonalInfo画面表示機能
iiidea強制ダウンロード機能を使ってダウンロードしたiiideaはRiiiverのストアを経由していないため、個人情報の使用許可を取るルートがなくなります。(ストアでは個人情報を使用してるiiideaをダウンロードする前にユーザーに許可を得る画面を表示する)  
iiidea強制ダウンロード機能を使って個人情報を使用しているiiideaをダウンロードした場合、iiideaのactivate時にエラーとなります。  
このエラーが発生した場合に解消する機能がPersonalInfo画面表示機能となります。  
iiidea強制ダウンロード機能を使用する場合は必ず本機能を使った対応を入れてください。  

#### 実装方法(iOS)
新規に以下のエラー値が追加されています。  
|  Enum  |  Class  | 説明 | 実装参考 |
| ---- | ---- | ---- | ---- |
| personalInfoError |  ERSDKError  | iiidea強制ダウンロード機能を使ってダウンロードした"個人情報を使用しているiiidea"をActivateした時に発生 | サンプルアプリの IiideaInfoViewController をご確認ください。 (activate APIの結果でpersonalInfoErrorが発生した場合にERPersonalInformationViewを表示) |

上記のエラーが発生した場合にERPersonalInformationViewを画面上に表示します。  
ERPersonalInformationViewの機能は以下となります。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
| load(applet: ERApplet, delegate: ERPersonalInformationViewDelegate)  |  ERPersonalInformationView  | inputパラメータのappletで指定したiiideaで必要となる個人情報の許可を得る画面をERPersonalInformationView上に表示する。画面のクローズ要求、または許可が得られた場合はERPersonalInformationViewDelegateにより検知できる。 | サンプルアプリの PersonalInfoViewController をご確認ください。 |
| closeView(applet: ERApplet) -> Void |  ERPersonalInformationViewDelegate  | 個人情報の許可が得られずに画面クローズした場合に呼ばれる。personalInfoErrorは解消されない。 | サンプルアプリの PersonalInfoViewController をご確認ください。 |
| personalInfoAllowed(applet: ERApplet) -> Void |  ERPersonalInformationViewDelegate  | 個人情報の許可が得られた場合に呼ばれる。personalInfoErrorは解消される。 | サンプルアプリの PersonalInfoViewController をご確認ください。 |

#### 実装方法(Android)
新規に以下のエラー値が追加されています。  
|  Enum  |  Class  | 説明 | 実装参考 |
| ---- | ---- | ---- | ---- |
| ERErrorCode.ER_ERROR_CODE_PERSONAL_INFO_ERROR |  ERError  | iiidea強制ダウンロード機能を使ってダウンロードした"個人情報を使用しているiiidea"をActivateした時に発生 | サンプルアプリの PersonalInfoFragment をご確認ください。 (activate APIの結果でER_ERROR_CODE_PERSONAL_INFO_ERRORが発生した場合にERPersonalInformationViewを表示) |

上記のエラーが発生した場合にERPersonalInformationViewを画面上に表示します。  
ERPersonalInformationViewの機能は以下となります。  
|  API  |  Class  | 機能  | 実装参考 |
| ---- | ---- | ---- | ---- |
| load(ERApplet applet, ERPersonalInformationViewDelegate delegate)  |  ERPersonalInformationView  | inputパラメータのappletで指定したiiideaで必要となる個人情報の許可を得る画面をERPersonalInformationView上に表示する。画面のクローズ要求、または許可が得られた場合はERPersonalInformationViewDelegateにより検知できる。 | サンプルアプリの PersonalInfoFragment をご確認ください。 |
| closeView(ERApplet var1) |  ERPersonalInformationViewDelegate  | 個人情報の許可が得られずに画面クローズした場合に呼ばれる。ER_ERROR_CODE_PERSONAL_INFO_ERRORは解消されない。 | サンプルアプリの PersonalInfoFragment をご確認ください。 |
| personalInfoAllowed(ERApplet var1) |  ERPersonalInformationViewDelegate  | 個人情報の許可が得られた場合に呼ばれる。ER_ERROR_CODE_PERSONAL_INFO_ERRORは解消される。 | サンプルアプリの PersonalInfoFragment をご確認ください。 |