//
//  StoreViewController.swift
//  sample
//
//  Created by CITIZEN Watch Co.,Ltd on 2019/10/30.
//  Copyright © 2019 CITIZEN Watch Co.,Ltd. All rights reserved.
//

import Foundation
import UIKit
import WebKit
import RiiiverSDK

class ProfileViewController: UIViewController, ERAuthProfileWebViewDelegate {
    /// The web view for the Riiiver (iiiidea) Store. - iiideaStore用WebView
    @IBOutlet weak var webStore: WKWebView!
    
    var isLogout = false
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        // プロフィール画面表示  -  Display the webview for the profile.
        RiiiverSDKManager.shared.openProfile(webView: webStore, delegate: self)
    }

    func onLogout() {
        // プロフィール画面上でログアウトされた時に呼ばれる
        isLogout = true
    }
    
    func onError(_ err: Error) {
        print("\(err)")
    }

    @IBAction func back(_ sender: Any) {
        screenTransition()
    }
    
    private func screenTransition() {
        if (isLogout == true) {
            // ログアウトされた場合はログイン画面を表示
            self.presentingViewController?.presentingViewController?.dismiss(animated: true, completion: nil)
        }
        else {
            self.dismiss()
        }
    }
    
    private func dismiss() {
        if let sampleViewController = self.presentingViewController as? SampleViewController {
            sampleViewController.isReload = true
        }
        self.dismiss(animated: true, completion: nil)
    }
    
}
