//
//  ViewController.swift
//  sample
//
//  Created by CITIZEN Watch Co.,Ltd on 2019/10/23.
//  Copyright © 2019 CITIZEN Watch Co.,Ltd. All rights reserved.
//

import Foundation
import UIKit
import WebKit
import RiiiverSDK
import SafariServices

class ViewController: UIViewController {
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        if (RiiiverSDKManager.shared.authenticated == false ){
            // Web認証画面表示  -  Display the webview for the authentication.
            RiiiverSDKManager.shared.startWebLogin { url, error in
                if let error = error {
                    print("\(error)")
                    return
                }
                if let url = url {
                    // ログイン画面を起動
                    self.present(SFSafariViewController(url: url), animated: false, completion: nil)
                }
            }
        }
        else {
            // 既に認証済みの場合は次の画面へ - If the user have already authenticated, goto next ViewController.
            nextViewController()
        }
    }
    
    /// RiiiverSDKにWebLogin情報を設定する
    func challengeAuthByWebLogin() {
        RiiiverSDKManager.shared.challengeAuthByWebLogin() { error, authToken in
            if(error != nil){
                print("error. \(String(describing: error))")
            }
            self.nextViewController()
        }
    }

    func nextViewController() {
        // 強制ダウンロード対象のiiideaを設定
        RiiiverSDKManager.shared.forcedDownloadApplet() {isSuccess,error in
            self.performSegue(withIdentifier: "toSample", sender: self)
        }
    }

    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        if let sampleViewController = segue.destination as? SampleViewController {
            sampleViewController.isReload = true
        }
    }
}
